	SUBROUTINE STATIS
	IMPLICIT REAL*8(A-H,O-Z)
	CHARACTER*80 TITLE
	CHARACTER*32 NAME
	INTEGER EACHIT
	INTEGER NVA(4),NVARAB(4,15),NVAR(20),NVARS(20),NEST(5),NALF(5),
     *      NVM(5),NWC(30),WY(20,20),ADJ(40,2),WADJ(40),NCM(5),NCT(5),
     *      NNZ(20)
	LOGICAL COREST(5),CORALF(5),CORVM(5)
	REAL*8 PP(5,5),BE(4,15),LK(15),JED(50,50),H(50,50),STDE(50),
     *      P(15,5),QCOMP(20,20),WW(50),VCOMP(40),EST(5),ALFA(5),VM(5)
	COMMON
     *      /UNI/ M,N,MM,NWAVE,NWAVAR,NREDE,NSTODE,NCHAR,NCHARV,NSPEK,
     *      NPOT,NIM,NNREDE,MNREDE,NREDE1,M1,MX,MX1,ISOL,NPARAM,MXNWA1
     *      ,MXNWA,NEXP,NUMIT,MAXMAR,MAXIT,MAXU,KON30,KON15,KON5,
     *      EACHIT,MMM,MMX,MXX,MXX1,MXC,MXW,MXV,MXVV,MXA,NPC        ,
     *      NVRTEX,NVRTXC,NADJ,NADJC,NCOMP,NCOMP1
     *      /U1/
     *      BLOG,RMIND,REL,DUMDT,RLAMBD,VMARQ,WNORM,RKRYT,EST,ALFA,
     *      SIGEMF,SIGMAV,COEXP,PARS,UZG,FACTST
	COMMON
     *      /C1/ NVA,NVARAB
     *      /C2/ BE
     *      /C6/ VM
     *      /C11/ H
     *      /C12/ P
     *      /C17/ LK
     *      /C22/ NWC,WADJ,NVAR,NVARS,NVM,NALF,NEST
     *      /C23/ WY,NNZ,NCM,NCT,ADJ
     *      /C24/ QCOMP,WW,VCOMP     
     *      /C27/ CORVM,COREST,CORALF
             COMMON /NAMES/ TITLE,NAME(15)
	K=NPOT+NWAVE*NSPEK+MMM+NPC-NPARAM
	IF(K.LE.0) RETURN
	DO 1 I=1,NPARAM
1	  JED(I,I)=1.0
	IF(NPARAM.EQ.1)GOTO 2
	DO 3 I=2,NPARAM
	  I1=I-1
	  DO 4 J=1,I1
	    JED(I,J)=0.0
4	  JED(J,I)=0.0
3	  CONTINUE
2	CONTINUE
	CALL OPTCH(H,JED,KON30,NPARAM,NPARAM,*6)
	Z=UZG/K
	DO 5 I=1,NPARAM
	STDE(I)=DSQRT(JED(I,I)*Z)
	DO 8 J=1,NPARAM
8	JED(I,J)=JED(I,J)*Z
5	CONTINUE
	WRITE(9,1003)
1003	FORMAT (/11X,'Variance-covariance matrix of parameters:')
	CALL PIS(50,1,NPARAM,1,NPARAM,6,JED)
	WRITE (9,'(/80(1H*)/A/80(1H*))') TITLE
	WRITE (9,'(/2a/)') 'Calculated parameters and their standard ',
     &                    'deviations (in parentheses):'
	IF (NREDE.EQ.0) GOTO 10
	WRITE(9,'(/a/)') 
     &      'Stoichiometric coefficients of unknown species:'
	K=MM
	DO 20 I=1,NREDE
	DO 20 J=1,NSTODE
	  K=K+1
	  PP(I,J)=FACTST*STDE(K)
20	CONTINUE
        WRITE (9,'(9x,5a15)') (NAME(I)(:15),I=M+1,M+NSTODE)
	DO I=1,NREDE
          WRITE (9,'(i2,2x,5(f6.2,1h(,f5.2,1h),2x))') 
     &              i,(-p(i,j),pp(i,j),j=1,nstode)
        ENDDO
10	WRITE (9,'(/a/)') 'Equilibrium constants and their logarithms:'
        WRITE (9,'(a,12x,a,20x,a)') 'Nr','K','log K'
	DO 30 I=1,MM
	AK=DEXP(LK(I))*STDE(I)
	ALK=STDE(I)/BLOG
	WRITE (9,1002) i,dexp(lk(i)),ak,lk(i)/blog,alk
30	CONTINUE
1002	FORMAT(i2,2x,1pd12.4,'(',1pd8.2,')',2x,0pf8.4,'(',f7.4,')')
	IF(MX.EQ.MXC) GOTO 11
	WRITE(9,1007)
1007	FORMAT(//'Composition parameters:'//
     &         'The amounts of species in the basic solutions(solids).')
	DO 12 I=1,NCOMP
	NVARI=NVAR(I)
	IF (NVARI.EQ.0) GOTO 12
	  NVARSI=NVARS(I)
          WRITE(9,1008)I,(NAME(WY(I,J))(:8),QCOMP(I,J),STDE(NVARSI+J),
     &	  J=1,NVARI)
12	CONTINUE
11	CONTINUE
	IF(NVRTXC.EQ.0) GOTO 13
	WRITE (9,1009)(NWC(I),1.0/WW(NWC(I)),STDE(MXC+I),I=1,NVRTXC)
1008	FORMAT(/'Solution (solid) number',i2
     &          /1x,20(a8,3x,1pd11.4,'(',1pd10.4,')'/))
1009	FORMAT(//'Total volumes:'/20(i3,3x,1pd11.4,'(',1pd10.4,')'/))
13	CONTINUE
	IF(NADJC.EQ.0) GOTO 17
	WRITE(9,1010)(ADJ(WADJ(I),1),ADJ(WADJ(I),2),VCOMP(WADJ(I)),
     &	              STDE(MXW+I),I=1,NADJC)
1010	FORMAT(//1X,'Partial volumes of solutions:'/
     &      40(2I5,3X,1PD11.4,'(',1pd10.4,')'/))
17	CONTINUE
	WRITE(9,1011)
1011	FORMAT(//1X,' No',8x,'Vm',18x,'Eo',19x,'S')
	DO 14 I=1,NEXP
	  Y1=-1.0D-10
	  Y2=-1.0D-10
	  Y3=-1.0D-10
	  IF(CORVM(I)) GOTO 15
	  Y1=STDE(NVM(I))
15	  CONTINUE
	  IF(CORALF(I)) GOTO 16
	  Y2=STDE(NALF(I))
16	  CONTINUE
	  IF(COREST(I)) GOTO 14
18	  Y3=STDE(NEST(I))
14	  WRITE(9,1012) I,VM(I),Y1,EST(I),Y3,ALFA(I),Y2
1012    FORMAT(I3,2X,F7.2,'(',F7.2,')',2x,F9.2,
     &         '(',F8.2,')',2x,F9.3,'(',F8.3')')
	IF (NWAVAR.EQ.0) RETURN
	K=K+MM
	WRITE(9,1999)
1999	FORMAT(//'Standard deviations of molar abs. coefficients'//)
	DO 50I=1,NWAVAR
	NVAI=NVA(I)
	WRITE(9,1004)(NVARAB(I,J),J=1,NVAI)
1004	FORMAT(  //5X,8I12 )
	WRITE(9,1005)I
1005	FORMAT(/1X,I3,2X)
	DO 60J=1,NVAI
	K=K+1
	  SBE=BE(I,NVARAB(I,J))*STDE(K)
	WRITE(9,1006) SBE
1006	FORMAT('+',D10.4,2X)
60	CONTINUE
50	CONTINUE
	GOTO 7
6	WRITE(9,10000)
10000	FORMAT(/'The Jacobian is not of the full rank.'/
     &  'Standard deviations of parameters cannot be computed.'//)
7	CONTINUE
	RETURN
	END
